import requests
import json
from lxml import html

if __name__ == '__main__':

    c3s = [
        {'name': 'Fall 2008', 'forum_id': 256},
        {'name': 'Spring 2009', 'forum_id': 257},
        {'name': 'Fall 2009', 'forum_id': 1346},
        {'name': 'Spring 2010', 'forum_id': 4711},
        {'name': 'Fall 2010', 'forum_id': 2101},
        {'name': 'Spring 2011', 'forum_id': 20110},
        {'name': 'Spring 2012', 'forum_id': 2012},
        {'name': 'Summer 2013', 'forum_id': 18},
        {'name': 'Summer 2014', 'forum_id': 8888},
        {'name': 'Winter 2014', 'forum_id': 6843},
        {'name': 'Summer 2015', 'forum_id': 89},
        {'name': 'Winter 2016', 'forum_id': 777},
        {'name': 'Summer 2016', 'forum_id': 20162},
        {'name': 'Winter 2017', 'forum_id': 20171},
        {'name': 'Summer 2017', 'forum_id': 9998},
        {'name': 'Winter 2018', 'forum_id': 2018},
        {'name': 'Summer 2018', 'forum_id': 20182},
        {'name': 'Winter 2019', 'forum_id': 2019},
        {'name': 'Summer 2019', 'forum_id': 20192},
        {'name': 'Winter 2020', 'forum_id': 2020},
        {'name': 'Summer 2020', 'forum_id': 20202},
        {'name': 'Winter 2021', 'forum_id': 2021},
        {'name': 'Summer 2021', 'forum_id': 20212},
    ]

    for c3 in c3s:
        print(c3['name'])
        forum_id = c3['forum_id']
        threads = []
        num_stickies = 0

        page = 1
        found_new_threads = True
        while found_new_threads:
            url = f'https://www.smwcentral.net/?p=viewforum&f={forum_id}&page={page}'
            response = requests.get(url)
            tree = html.fromstring(response.text)

            found_new_threads = False
            for cell in tree.xpath('//td[@class="normal border cell2"]//td[1]'):
                if cell.text:
                    num_stickies += 1
                    continue
                user_name = cell.xpath('.//a[@class="un"]/text()')[0]
                user_id = cell.xpath('.//a[@class="un"]')[0].attrib['href'].split('=')[-1]
                thread_name = cell.xpath('./a/text()')[0]
                thread_id = cell.xpath('./a')[0].attrib['href'].split('=')[-1]
                thread = {'id': thread_id, 'name': thread_name, 'authors': [{'id': user_id, 'name': user_name}]}
                if thread not in threads:
                    found_new_threads = True
                    threads.append(thread)
            page += 1

        print(f'    {page - 2} pages with {len(threads)} threads ({len(threads) + num_stickies} including stickies)')
        c3['threads'] = threads

    c3s_json = json.dumps(c3s)
    with open('c3s.json', 'w', encoding='utf-8') as f:
        f.write(c3s_json)

    print(c3s)
